<?php

/**
 * Copyright 2024-2025 Simply.IN Sp. z o.o.
 *
 * NOTICE OF LICENSE
 *
 * Licensed under the EUPL-1.2 or later.
 * You may not use this work except in compliance with the Licence.
 *
 * Copy of the Licence is available at:
 * https://joinup.ec.europa.eu/software/page/eupl
 * It is bundled with this package in the file LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the Licence is distributed on an as is basis,
 * without warranties or conditions of any kind, either express or implied.
 * Check the Licence for the specific language governing permissions
 * and limitations under the License.
 *
 * @author   Simply.IN Sp. z o.o.
 * @copyright 2024-2025 Simply.IN Sp. z o.o.
 * @license   https://joinup.ec.europa.eu/software/page/eupl
 */

declare(strict_types=1);

namespace SimplyIn\Checkout;

use Db;

if (!defined('_PS_VERSION_')) {
    exit;
}

final class OrderIpResolver
{
    public function resolve(int $idOrder): string
    {
        $sql = '
            SELECT      c.`ip_address`
            FROM        `' . _DB_PREFIX_ . 'connections` c
            JOIN        `' . _DB_PREFIX_ . 'guest` g
                ON      c.id_guest = g.id_guest
            JOIN        `' . _DB_PREFIX_ . 'orders` o
                ON      g.id_customer = o.id_customer
            WHERE       o.id_order = ' . $idOrder;

        $ipAddress = Db::getInstance()->getValue($sql);
        if (!empty($ipAddress)) {
            return long2ip((int) $ipAddress);
        }

        return '';
    }
}
